package net.sf.basedb.util.excel;

import net.sf.basedb.util.formatter.Formatter;

/**
	Excel formatter implementation that uses the value
	from any parent formatter and creates a string cell 
	value.

	@author nicklas
	@since 3.15
*/
public class WrappedFormatter<T> 
	implements ExcelFormatter<T, String>
{

	private final Formatter<T> parent;
	public WrappedFormatter(Formatter<T> parent)
	{
		this.parent = parent;
	}

	@Override
	public ExcelValue<String> toExcelValue(T value)
	{
		return ExcelValue.asString(parent.format(value));
	}

}
