/*
	$Id: TestSession.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
import net.sf.basedb.core.*;

public class TestSession
{

	static boolean ok = true;

	public static void main(String[] args)
	{
		TestUtil.checkArgs(args);
		TestUtil.begin();
		ok = test_all();
		TestUtil.stop();
	}

	static boolean test_all()
	{
		write("++Testing session");
		write_header();
		// Standard tests: only list has meaning
		test_list();

		// Extra tests:

		// Standard test: Delete - not applicable to session items

		write("++Testing session "+(ok ? "OK" : "Failed")+"\n");
		return ok;
	}

	static void test_list()
	{
		DbControl dc = null;
		try
		{
			dc = TestUtil.getDbControl();
			ItemResultList<Session> l = Session.getQuery(null).list(dc);
			for (int i = 0; i<l.size(); i++)
			{
				write_item(i, l.get(i));
			}
			write("--List sessions OK ("+l.size()+")");
		}
		catch (Throwable ex)
		{
			write("--List sessions FAILED");
			ex.printStackTrace();
			ok = false;
		}
		finally
		{
			if (dc != null) dc.close();
		}
	}

	static void write_header()
	{
		if (!TestUtil.getSilent())
		{
			write("   \tID \tLogin time\tLogout time\tUser\tClient");
			write("-- \t-- \t----------\t-----------\t----\t------");
		}
	}
	static void write_item(int i, Session ses)
		throws BaseException
	{
		if (!TestUtil.getSilent()) System.out.println(i+":\t"+ses.getId()+"\t"+
			ses.getLoginTime()+"\t"+ses.getLogoutTime()+"\t"+ses.getUser()+"\t"+ses.getClient());
	}
	static void write(String message)
	{
		System.out.println(message);
	}

}

