<%-- $Id: list_rawbioassays.jsp 8046 2022-07-26 06:58:45Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.AnnotationLoaderUtil"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.clients.web.formatter.LinkedItemFormatter"
	import="net.sf.basedb.clients.web.formatter.DataFileFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.clients.web.extensions.fileviewer.FileViewerContext"
	import="net.sf.basedb.clients.web.extensions.fileviewer.FileViewerUtil"
	import="net.sf.basedb.clients.web.util.ProjectSpecificInfoFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.RAWBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final boolean readPermission = sc.hasPermission(Permission.READ, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final Formatter<Nameable> nameableFormatter = mode.hasPropertyLink() ? new LinkedItemFormatter(mode.hasEditLink()) : new NameableFormatter();
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("raw bioassay", "raw bioassays");
final DbControl dc = sc.newDbControl(":List "+itemType);
ItemResultIterator<RawBioAssay> rawBioAssays = null;
List<AnnotationLoaderUtil> annotationLoaders = new ArrayList<AnnotationLoaderUtil>();
try
{
	ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	SnapshotManager manager = new SnapshotManager();
	ProjectSpecificInfoFilter psInfo = new ProjectSpecificInfoFilter();
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
	}
	annotationTypeQuery = Base.getInheritedAnnotationColumns(cc.getSetting("columns"));
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at, false, true));
	}
	List<DataFileType> fileTypeColumns = new ArrayList<DataFileType>(Base.getDataFileColumns(itemType, null).list(dc));

	final ItemQuery<ItemSubtype> jobSubtypesQuery = Base.getSubtypesQuery(Item.JOB);
	
	// Query for experiments relatated to the current raw bioassay
	final ItemQuery<Experiment> experimentQuery = Experiment.getQuery();
	experimentQuery.setIncludes(cc.getInclude());
	experimentQuery.join(Hql.innerJoin("rawBioAssays", "rba"));
	experimentQuery.restrict(Restrictions.eq(Hql.alias("rba"), Expressions.parameter("rawBioAssay")));
	experimentQuery.order(Orders.asc(Hql.property("name"))); 

	// List membership
	final ItemQuery<ItemList> listQuery = ItemList.getQuery();
	listQuery.setIncludes(cc.getInclude());
	listQuery.join(Hql.innerJoin("members", "m"));
	listQuery.restrict(Restrictions.eq(Hql.property("memberType"), Expressions.integer(itemType.getValue())));
	listQuery.restrict(Restrictions.eq(Hql.alias("m"), Expressions.parameter("itemId", Type.INT)));
	listQuery.order(Orders.asc(Hql.property("name")));

	// Get all platforms
	final ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.setIncludes(cc.getInclude());
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	Enumeration<String, String> platforms = new Enumeration<String, String>();
	for (Platform p : platformQuery.list(dc))
	{
		platforms.add(Integer.toString(p.getId()), p.getName());
	}
	
	Unit bytes = UnitUtil.getUnit(dc, Quantity.STORAGE_SIZE, "B");
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	try
	{
		final ItemQuery<RawBioAssay> query = Base.getConfiguredQuery(dc, cc, jspContext, true, RawBioAssay.getQuery(), mode);
		rawBioAssays = query.iterate(dc);
	}
	catch (Throwable t)
	{
		t.printStackTrace();
		cc.setMessage(t.getMessage());
	}
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	int numListed = 0;
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker<ListColumnAction<RawBioAssay,?>> columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	FileViewerUtil fileViewer = FileViewerUtil.getOrCreate(jspContext, FileViewerContext.file());
	%>
	<base:page title="<%=title==null ? "Raw bioassays" : title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,~bioassays.js" styles="table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<h1><%=title==null ? "Raw bioassays" : title%></h1>
		<div class="content">
		<tbl:table 
			id="rawbioassays" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subclass="fulltable"
			filterrows="<%=cc.getFilterRows()%>"
			data-inherited-annotations="true"
			data-relateditem-columns="true"
			stickyheaders="<%=cc.getSetting("columns.sticky", "name")%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id" 
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="entryDate"
				property="entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="platform"
				property="platform"
				sortproperty="platform.name"
				exportproperty="platform.name:string"
				datatype="int"
				enumeration="<%=platforms%>"
				title="Platform"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="variant"
				property="variant.name"
				datatype="string"
				title="Variant"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>				
			<%
			Enumeration<String, String> rawEnumeration = new Enumeration<String, String>();
			for (RawDataType rdt : RawDataTypes.getRawDataTypes())
			{
				rawEnumeration.add(rdt.getId(), HTML.encodeTags(rdt.getName()));
			}
			rawEnumeration.sortValues();
			%>
			<tbl:columndef 
				id="rawDataType"
				property="rawDataType"
				datatype="string"
				enumeration="<%=rawEnumeration%>"
				title="Raw data type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="hasData"
				property="hasData"
				datatype="boolean"
				title="Has data"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="spots"
				property="spots"
				datatype="int"
				title="Db spots"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="numFileSpots"
				property="numFileSpots"
				datatype="int"
				title="File spots"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>			
			<tbl:columndef 
				id="bytes"
				property="bytes"
				datatype="long"
				title="Bytes"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=bytes%>"
			/>
			<tbl:columndef 
				id="parentBioAssay"
				property="parentBioAssay.name"
				datatype="string"
				title="Parent bioassay"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="parentExtract"
				property="parentExtract.name"
				datatype="string"
				title="Parent extract"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="software"
				property="software.name"
				datatype="string"
				title="Software"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="protocol"
				property="protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="arrayDesign"
				property="arrayDesign.name"
				datatype="string"
				title="Array design"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="jobType"
				property="job.itemSubtype"
				sortproperty="job.itemSubtype.name"
				exportproperty="job.itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(jobSubtypesQuery.list(dc), "-none-")%>"
				title="Job type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="plugin"
				property="job.pluginDefinition.name"
				datatype="string"
				title="Plugin"
				sortable="true"
				filterable="true"
				exportable="true"
				tooltip="The plug-in that was used to create data for the raw bioassay"
			/>
			<tbl:columndef 
				id="configuration"
				property="job.pluginConfiguration.name"
				datatype="string"
				title="Configuration"
				sortable="true"
				filterable="true"
				exportable="true" 
				tooltip="The configuration/file format that was used to create data for the raw bioassay"
			/>
			<tbl:columndef 
				id="importdate"
				property="job.ended"
				datatype="date"
				title="Import date"
				sortable="true"
				filterable="true"
				exportable="true" 
				tooltip="The date and time of the raw data import"
				formatter="<%=dateTimeFormatter%>"
			/>
			<tbl:columndef
				id="experiments"
				title="Experiments"
				property="&experiments(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef
				id="itemList"
				property="§itemLists"
				datatype="int"
				title="Item list"
				filterable="true"
				enumeration="<%=Base.getItemListsEnum(dc, itemType, cc.getInclude())%>"
			/>
			<%
			for (AnnotationLoaderUtil loader : annotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Formatter<Object> formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				Enumeration<String, String> annotationEnum = null;
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					if (!at.getDisplayAsList()) annotationEnum.add("", "-none-");
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = HTML.encodeTags(value.toString());
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+(loader.isSearchingInheritedAnnotations() ? " [I]" : " [A]")%>" 
					property="<%=(loader.isSearchingInheritedAnnotations() ? "##" : "#")+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1 && !loader.isSearchingInheritedAnnotations()%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			for (DataFileType ft : fileTypeColumns)
			{
				%>
				<tbl:columndef
					subclass="controlled-width"
					id="<%="ft"+ft.getId()%>"
					title="<%=HTML.encodeTags(ft.getName())+" [F]"%>"
					property="<%="¤" + ft.getId()+"(file.name)"%>"
					exportproperty="<%="¤" + ft.getId()+"(file.path)"%>"
					datatype="string"
					filterable="true"
					sortable="false"
					exportable="true"
					formatter="<%=new DataFileFormatter(dc, ft, mode, fileViewer) %>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						id="btnNewItem"
						disabled="<%=!createPermission%>" 
						image="new.png" 
						title="New&hellip;" 
						tooltip="<%=createPermission ? "Create new raw bioassay" : "You do not have permission to create raw bioassays"%>" 
					/>
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Delete the selected items" 
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected (deleted) items"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						id="btnNewItemList"
						image="add.png"
						title="New item list&hellip;"
						tooltip="Create a new item list from matching raw bioassays"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.ITEMLIST)%>"
					/>
					<tbl:button
						id="btnAddToItemList"
						image="add.png"
						title="Add to item list&hellip;"
						tooltip="Add raw bioassays to an existing item list"
					/>
					<tbl:button
						id="btnNewExperiment"
						image="add.png"
						title="New experiment&hellip;"
						tooltip="Create a new experiment from the selected raw bioassays"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.EXPERIMENT)%>"
					/>
					<tbl:button
						id="btnInheritAnnotations"
						image="inherit.png"
						title="Inherit annotations&hellip;"
						tooltip="Batch inherit annotations from parent items"
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=rawBioAssays == null ? 0 : rawBioAssays.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header clazz="row-index bg-filled-100" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="row-index bg-filled-100">
								<div class="index-<%=mode.getName()%>">
									<div class="index"></div>
									<div class="check">
										<base:icon 
											subclass="link table-check"
											image="check_uncheck.png" 
											tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
											visible="<%=lastRow && mode.hasCheck()%>"
										/>
									</div>
									<div class="icons">
										<base:icon
											subclass="link table-filter-row-action"
											image="add.png"
											tooltip="Add extra filter row"
											visible="<%=lastRow%>"
										/><base:icon
											subclass="link table-filter-row-action"
											image="remove.png"
											tooltip="Remove this filter row"
											visible="<%=numRows > 1 || numFilters > 0 %>"
											data-remove-row="<%=filterNo%>"
										/>
									</div>
								</div>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
					<tbl:columnsubtitles />
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (rawBioAssays != null)
					{						
						while (rawBioAssays.hasNext())
						{
							RawBioAssay item = rawBioAssays.next();
							Job job = null;
							try
							{
								job = item.getJob();
							}
							catch (Throwable t)
							{}
							int itemId = item.getId();
							
							
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header clazz="row-index bg-filled-100">
									<div class="index-<%=mode.getName()%>">
										<div class="index <%=index>999?"index-smaller":""%>"><%=index%></div>
										<div class="check">
											<base:input
												type="checkbox" 
												name="<%=itemId%>" 
												value="<%=itemId%>" 
												title="<%=name%>" 
												checked="<%=cc.getSelected().contains(itemId)%>"
												visible="<%=mode.hasCheck()%>"
											/>
											<base:input 
												type="radio" 
												name="item_id" 
												value="<%=itemId%>" 
												title="<%=name%>" 
												checked="<%=selectedItemId == itemId%>"
												visible="<%=mode.hasRadio()%>"
											/>
										</div>
										<div class="icons">
											<base:icon 
												image="deleted.png"
												id="<%="delete."+itemId %>"
												subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
												data-item-id="<%=itemId%>"
												tooltip="This item has been scheduled for deletion" 
												visible="<%=item.isRemoved()%>"
											/><base:icon 
												image="shared.png" 
												id="<%="share."+itemId %>"
												subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
												data-item-id="<%=itemId%>"
												tooltip="This item is shared to other users, groups and/or projects" 
												visible="<%=item.isShared()%>"
											/>
										</div>
									</div>
								</tbl:header>
								<tbl:cell column="name"><div 
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									tabindex="0"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="spots"><%=item.getNumDbSpots()%></tbl:cell>
								<tbl:cell column="numFileSpots"><%=item.getNumFileSpots()%></tbl:cell>
								<tbl:cell column="bytes"><%=Values.formatBytes(item.getBytes())%></tbl:cell>
								<tbl:cell column="platform"
									><base:propertyvalue 
										item="<%=item%>" 
										property="platform"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="variant"
									><base:propertyvalue 
										item="<%=item%>" 
										property="variant"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>								
								<tbl:cell column="rawDataType"><%=HTML.encodeTags(item.getRawDataType().getName())%></tbl:cell>
								<tbl:cell column="hasData"><%=item.hasData()%></tbl:cell>
								<tbl:cell column="parentBioAssay"
									><base:propertyvalue 
										item="<%=item%>" 
										property="parentBioAssay"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="parentExtract"
									><base:propertyvalue 
										item="<%=item%>" 
										property="parentExtract"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="software"
									><base:propertyvalue 
										item="<%=item%>" 
										property="software"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="protocol"
									><base:propertyvalue 
										item="<%=item%>" 
										property="protocol"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="arrayDesign"
									><base:propertyvalue 
										item="<%=item%>" 
										property="arrayDesign"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="jobType"><base:propertyvalue 
										item="<%=item%>" 
										property="job.itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="plugin">
									<base:propertyvalue 
										item="<%=item%>"
										property="job.pluginDefinition" 
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
										/>
								</tbl:cell>
								<tbl:cell column="configuration">
									<base:propertyvalue 
										item="<%=item%>"
										property="job.pluginConfiguration" 
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/>
								</tbl:cell>
								<tbl:cell 
									column="importdate" 
									value="<%=job == null ? null : job.getEnded() %>" 
								/>
								<tbl:cell column="itemList">
									<%
									listQuery.setParameter("itemId", itemId, Type.INT);
									%>
									<%=Values.getString(listQuery.list(dc), ", ", false, nameableFormatter) %>
								</tbl:cell>
								<tbl:cell column="experiments">
									<%
									experimentQuery.setParameter("rawBioAssay", itemId, Type.INT);
									%>
									<%=Values.getString(experimentQuery.list(dc), ", ", false, nameableFormatter) %>
								</tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<%
								if (item.hasFileSet())
								{
									FileSet fileSet = item.getFileSet();
									for (DataFileType ft : fileTypeColumns)
									{
										%>
										<tbl:cell column="<%="ft"+ft.getId()%>" value="<%=fileSet%>" />
										<%
									}
								}
								if (item.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, item.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : annotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.hasProjectSpecificAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%=Values.getString(ShareableUtil.getSharedTo(dc, item), ", ", false, nameableFormatter) %>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
							<%=rawBioAssays == null || rawBioAssays.getTotalCount() == 0 ? "No raw bioassays were found" : "No raw bioassays on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (rawBioAssays != null) rawBioAssays.close();
	if (dc != null) dc.close();
}
%>
